#if defined(USE_WINFILE)||defined(__linux__)
#ifdef USE_WINFILE

#include <windows.h>
#include <w32api/winbase.h>
#include <stdio.h>
#include <w32api/winnt.h>
#include <WinIoCtl.h>
#include "system.h"
#endif
#include <errno.h>
#include "editor.h"
#include "main.h"
#include "getfile.h"
#define erroruit printf
FILEHANDLE openreading(const char *filename) ;

char *assigndev(int len) {
	char **devptr=(char **)malloc(sizeof(char *)+len);
	*devptr=NULL;
	return (char *)&devptr[1];
	}
inline void freearray(char **devices,int maxdriv) {
	for(int i=0;i<maxdriv;i++) {
		char **devptr= (char **)devices[i];
		if(*--devptr)
			free(*devptr);
		free(devptr);
		}
	free(devices);
	}
#ifdef USE_WINFILE
#ifdef BIOSDISK
#include "biosdisk.h"
#endif
#define MAXDRIVES 40
#ifdef BIOSDISK
inline int doswin(void) {
extern OSVERSIONINFO WindowsVersion;
	return WindowsVersion.dwOSVersionInfoSize&&WindowsVersion.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS;
	}

//s/=[^=]*malloc/=assigndev
int getbiosdrives(char ***devicesptr) {
	int drivenr=0; /*total number of 'drives' (physical+logical) */
	char **devices=(char **)malloc(sizeof(char *)* MAXDRIVES );
if(!devices)
	return -1;
	*devicesptr=devices;
	for(drivenr=0;drivenr<MAXDRIVES;drivenr++) {
			if(!(diskpresent(drivenr|0x80))) {
					break;
					}
			const int end=17;
			char disk[]="\\\\.\\PHYSICALDRIVE";
			char *dev=devices[drivenr]=assigndev(end+4+1);	
			strcpy(dev,disk);
			sprintf(dev+end,"%d",drivenr);	
			}
	for(int flopiter=0;drivenr<MAXDRIVES;drivenr++,flopiter++) {
			if(!(diskpresent(flopiter))) {
					break;
					}
			devices[drivenr]=assigndev(7);	
			sprintf(devices[drivenr],"\\\\.\\%c:",'A'+flopiter);
			}
	if(drivenr<1)
		free(devices);
	return drivenr;
	}
#endif

int getNTdrives(char ***devicesptr) {
	HANDLE filehandle;
	const int maxhard=30;
char **devices=(char **)malloc(sizeof(char *)* MAXDRIVES );
if(!devices)
	return -1;

*devicesptr=devices;
int diskiter=0;
	for(int i=0;i<maxhard;i++) {
		const int end=17;
		char disk[]="\\\\.\\PHYSICALDRIVE";
		char *dev=devices[diskiter]=assigndev(end+4+1+22);	
		char *tmp=(char *)malloc(end+5);
		strcpy(dev,disk);
		int pos=sprintf(dev+end,"%d",i)+end;	
		strcpy(tmp,dev);
		((char **)dev)[-1]=tmp;
		if((filehandle=openreading(dev))!=MY_INVALID_HANDLE_VALUE) 
			{
		GET_LENGTH_INFORMATION devlen;
		DWORD BytesReturned;

		if (DeviceIoControl(
		  filehandle,              // handle to device
		  IOCTL_DISK_GET_LENGTH_INFO,    // dwIoControlCode
		  NULL,                          // lpInBuffer
		  0,                             // nInBufferSize
		  (LPVOID) &devlen,          // output buffer
		  (DWORD) sizeof(devlen),        // size of output buffer
		  (LPDWORD) &BytesReturned,     // number of bytes returned
		  NULL    // OVERLAPPED structure
		)){
			sprintf(dev+pos," " OFFPRINT " ",devlen.Length.QuadPart);
			}
			diskiter++;
				CloseHandle(filehandle);
			}	
		}
	if(GetDriveType("A:\\")>1) 
	{
			devices[diskiter]=assigndev(7*sizeof(char));
			memcpy(devices[diskiter++],"\\\\.\\A:",7*sizeof(char));
	}	
	if(GetDriveType("B:\\")>1) 
	{
			devices[diskiter]=assigndev(7*sizeof(char));
			memcpy(devices[diskiter++],"\\\\.\\A:",7*sizeof(char));
	}	

{

typedef char VolNameType;
typedef char* VolNameTypePtr;
typedef WINBASEAPI HANDLE WINAPI (*FindFirstVolumeAType)(LPCSTR,DWORD);
typedef WINBASEAPI BOOL WINAPI (*FindNextVolumeAType)(HANDLE,LPCSTR,DWORD);
typedef WINBASEAPI BOOL WINAPI (*FindVolumeCloseType)(HANDLE);
typedef WINBASEAPI BOOL WINAPI (*GetVolumePathNamesForVolumeNameAType)(LPCSTR,LPSTR,DWORD,PDWORD);
//typedef WINBASEAPI BOOL WINAPI (*GetVolumeInformationByHandleWType)(HANDLE,LPSTR,DWORD,PDWORD,PDWORD,PDWORD,LPSTR,DWORD);
//typedef WINBASEAPI BOOL WINAPI (*GetVolumeInformationByHandleWType)(  HANDLE, LPWSTR, DWORD, LPDWORD, LPDWORD, LPDWORD, LPWSTR, DWORD);





class Volumes {
private:
BOOL success;
public:
 FindFirstVolumeAType FindFirstVolumeA;
 FindNextVolumeAType FindNextVolumeA;
 FindVolumeCloseType FindVolumeClose;
 GetVolumePathNamesForVolumeNameAType GetVolumePathNamesForVolumeNameA;
//GetVolumeInformationByHandleWType GetVolumeInformationByHandleW;
	Volumes(void) { 
		HMODULE kernel32=NULL;
		if(!(kernel32 = GetModuleHandle( "Kernel32.dll"))) {
			erroruit("GetModuleHandle( Kernel32.dll) failed");
			success=FALSE;return;
			}
/*
		if(!(GetVolumeInformationByHandleW =(GetVolumeInformationByHandleWType) GetProcAddress(kernel32,"GetVolumeInformationByHandleW"))) {
			erroruit("GetProcAddress(kernel32,GetVolumeInformationByHandleW) failed");
			}
*/
		if(!(FindFirstVolumeA =(FindFirstVolumeAType) GetProcAddress(kernel32,"FindFirstVolumeA"))) {
			erroruit("GetProcAddress(kernel32,FindFirstVolumeA) failed");
			success=FALSE;return;
			}
		if(!(FindNextVolumeA =(FindNextVolumeAType) GetProcAddress(kernel32,"FindNextVolumeA"))) {
			erroruit("GetProcAddress(kernel32,FindNextVolumeA) failed");
			success=FALSE;return;
			}
		if(!(FindVolumeClose =(FindVolumeCloseType) GetProcAddress(kernel32,"FindVolumeClose"))) {
			erroruit("GetProcAddress(kernel32,FindVolumeClose) failed");
			success=FALSE;return;
			}
		if(!(GetVolumePathNamesForVolumeNameA =(GetVolumePathNamesForVolumeNameAType) GetProcAddress(kernel32,"GetVolumePathNamesForVolumeNameA"))) {
			erroruit("GetProcAddress(kernel32,GetVolumePathNamesForVolumeNameA) failed");
			success=FALSE;return;
			}

	success=TRUE;
	};
inline  OFFTYPE getvolumesize(char *volume) {
  	GET_LENGTH_INFORMATION devlen;
	HANDLE filehandle=MY_INVALID_HANDLE_VALUE;
	DWORD BytesReturned;
	if((filehandle=openreading(volume))!=MY_INVALID_HANDLE_VALUE 
		&&DeviceIoControl(
		  filehandle,              // handle to device
		  IOCTL_DISK_GET_LENGTH_INFO,    // dwIoControlCode
		  NULL,                          // lpInBuffer
		  0,                             // nInBufferSize
		  (LPVOID) &devlen,          // output buffer
		  (DWORD) sizeof(devlen),        // size of output buffer
		  (LPDWORD) &BytesReturned,     // number of bytes returned
		  NULL    // OVERLAPPED structure
		)){
		return devlen.Length.QuadPart;
		};
	return (OFFTYPE) -1;
	}
int  getvolumegegs(char *volume,int namelen,char *buf,int maxbuf) {
	int buflen=0;
	DWORD 	pathslen;



	volume[namelen]='\\';
	volume[namelen+1]='\0';
	for(pathslen=maxbuf-buflen;! GetVolumePathNamesForVolumeNameA( volume, buf+buflen, pathslen, &pathslen);)  {
		if ( GetLastError() != ERROR_MORE_DATA )  
			{
			goto endgetvol;
			}
		else {
			free(buf);
			buf=(char *)malloc(sizeof(char)*(pathslen+buflen));
			}
		}

if(buf[buflen]) {

	int drivelen;
	char *iter=buf+buflen;
	for(;iter[0];) {
		drivelen=strlen(iter);
		*(iter+=drivelen)++=' ';
		}
	
	buflen+=(pathslen-1);

	*--iter='\0';
	char *lastdrive=iter-drivelen;

  	DWORD _VolumeSerialNumber, _MaximumComponentLength, _FileSystemFlags;
	DWORD nFileSystemNameSize=40;
	char FileSystemNameBuffer[nFileSystemNameSize];

 	UINT  drivetype=GetDriveType( lastdrive);
	if(drivetype!=5&&GetVolumeInformationA(lastdrive,buf+buflen , maxbuf-buflen,&_VolumeSerialNumber, &_MaximumComponentLength, &_FileSystemFlags, FileSystemNameBuffer, nFileSystemNameSize)) {
		buflen+=strlen(buf+buflen);
		*(buf+buflen++)=' ';
		buflen=strcpyn(buf+buflen,FileSystemNameBuffer,nFileSystemNameSize)-buf-1;
		volume[namelen]='\0';
		OFFTYPE volsize;
		if((volsize=getvolumesize(volume))>(OFFTYPE)0)
			buflen+=sprintf(buf+buflen," " OFFPRINT,volsize);
		}
	else
		volume[namelen]='\0';

	char *drivestr[]={"UNKNOWN", "NO_ROOT_DIR", "REMOVABLE", "FIXED", "REMOTE", "CD/DVD", "RAMDISK"};
	if(drivetype>=0&&drivetype<7){
		buflen+=sprintf(buf+buflen," %s ",drivestr[drivetype]);
		}
	*iter=' ';	
	}
else {
	endgetvol:
		volume[namelen]='\0';
		memcpy(buf+buflen,volume,namelen);
		buflen+=namelen;
		buf[buflen]='\0';
		OFFTYPE volsize;
		if((volsize=getvolumesize(volume))>(OFFTYPE)0)
			buflen+=sprintf(buf+buflen," " OFFPRINT,volsize);
	}

return buflen;
};
inline BOOL hasfinds(void) {
	return success;
	};
};
	static Volumes vol;
if(vol.hasfinds()) {
/* The following code concerning volume names is a modification of the example given at:	*
 *	http://msdn.microsoft.com/en-us/library/cc542456(VS.85).aspx 				*/
    VolNameType  VolumeName[MAX_PATH];
    DWORD  Error                = ERROR_SUCCESS;
    HANDLE FindHandle           = INVALID_HANDLE_VALUE;
    FindHandle = vol.FindFirstVolumeA(VolumeName, sizeof(VolumeName));

if (FindHandle == INVALID_HANDLE_VALUE)
    {
        Error = GetLastError();
        erroruit( "FindFirstVolumeA failed with error code 0x%X\n", Error);
    }
else {
    for (;;)
    {
    BOOL   Success              = FALSE;
    	size_t  Volnamelen = strlen(VolumeName) - 1;
        if (VolumeName[0]     !=   '\\' ||
            VolumeName[1]     !=   '\\' ||
            VolumeName[2]     !=   '?'  ||
            VolumeName[3]     !=   '\\' ||
            VolumeName[Volnamelen] !=   '\\') 
        {
            Error = ERROR_BAD_PATHNAME;
            erroruit( "FindFirstVolume/FindNextVolume returned a bad path: %s\n", VolumeName);
            break;
        }

        VolumeName[Volnamelen++] =   '\0';
	DEBUGGING("Volume: %s", VolumeName);
	int labellen=MAX_PATH;

	char **tmpdev=(char **)malloc(labellen*sizeof(char)+sizeof(char *));
	*tmpdev= (char *)malloc((Volnamelen)*sizeof(VolNameType));
	devices[diskiter]= (char *)&tmpdev[1];
	labellen=  vol.getvolumegegs(VolumeName,Volnamelen-1, devices[diskiter],labellen);
/*	if(labellen>maxshowcols)
		devices[diskiter][maxshowcols]='\0'; */
	diskiter++;

	memcpy(*tmpdev,VolumeName,sizeof(VolNameType)*Volnamelen);
        Success = vol.FindNextVolumeA(FindHandle, VolumeName, sizeof(VolumeName));

        if ( !Success ) 
        {
            Error = GetLastError();

            if (Error != ERROR_NO_MORE_FILES) 
            {
                erroruit( "FindNextVolumeA failed with error code 0x%X\n", Error);
                break;
            }
            Error = ERROR_SUCCESS;
            break;
        }
    }
    vol.FindVolumeClose(FindHandle);
    FindHandle = INVALID_HANDLE_VALUE;
   }
}
else {
	DWORD driv=	GetLogicalDrives();
	for(int i=0;i<32;i++) 
		if(driv&(1<<i)) {
			devices[diskiter]=assigndev(7);	
			sprintf(devices[diskiter++],"\\\\.\\%c:",'A'+i);
			}
}
 }

if(diskiter<1)
	free(devices);
return diskiter;
}

#endif /* USE_WINFILE */

#ifdef __linux__


int getLinuxdrives(char ***devicesptr) {
	char parts[]="/proc/partitions";
	FILE *han=fopen(parts,"rb");
	char buf[1024];
	long long bl;
	long maj,min;
	char name[512];
	long line=0,maxline;
	char **devices;
	if(!han) {
			fprintf(stderr,"Can't open %s\n",parts);
			return -1;
			}
	
	for(maxline=0;fgets(	buf,1024,han);maxline++) 
			;
	fseek(han,0L,SEEK_SET);
	if(!fgets(	buf,1024,han)) {
			fprintf(stderr,"%ld: read from %s failed\n",line,parts);
			fclose(han);
			return -1;
			}
	line++;
	if(!fgets(	buf,1024,han)) {
			fprintf(stderr,"%ld: read from %s failed\n",line,parts);
			fclose(han);
			return -1;
			}
	devices=(char **)malloc((maxline-2)*sizeof(char *));
	if(!devices) {
			fprintf(stderr,__FILE__ "%d malloc failed\n",__LINE__);
			fclose(han);
			return -1;
			}
	*devicesptr=devices;
	while(fgets(	buf,1024,han)) 
	{
		int len,num;
	  line++;
		if(sscanf(buf,"%ld%ld%lld%s",&maj,&min,&bl,name)!=4)
			fprintf(stderr,"%s line %ld: sscanf failed\n",parts,line);
		len=strlen(name);
		num=line-2;
		devices[num]=assigndev(len+5+1);
		strcpy(devices[num],"/dev/");
		strcpy(devices[num]+5,name);
	}
	fclose(han);
	if(line<2) 
		free(devices);
	return (line-1);
	}
#endif /* __linux__ */


int Editor::selectdisk(void) {
	int showwidth=70;
	int disknr=0; /*total number of 'drives' (physical+logical) */
	char **devices=NULL;
#ifdef USE_WINFILE
#ifdef BIOSDISK
if(doswin()) {
	if((disknr=getbiosdrives(&devices))<1)
			return disknr;
	}
else 
#endif
{

	if((disknr=getNTdrives(&devices))<1)
		return disknr;
}
#else // USE_WINFILE
#ifdef __linux__
	if((disknr=getLinuxdrives(&devices))<1)
		return disknr;

#endif // __linux__
#endif // USE_WINFILE
	static int take=0;
	int ant;
	if(take<0||take>=disknr)
		take=0;
	char label[]="Select drive and Press Enter";
	while((ant=selectitemindex(label,devices,disknr,take,showwidth))!=LONG_MAX) {
//	while((ant=selectitemindex(label,devices,disknr,take))!=LONG_MAX) {
			if(ant==(LONG_MAX-1)) {
				menuresized();
				wrefresh(editscreen);
				}
			else {
					editup();
					if(ant>=0&&ant<disknr) {
						take=ant;
						char *disk=devices[ant];
						char **devptr=(char **)disk;
						if(*--devptr) 
							disk=*devptr;
						if(!editfile(disk)) {
								beep();	
								message("Can't open %s",disk);
/*
								if(errno)
									erroruit("Can't open %s: %s",disk,strerror(errno));
								else 
									erroruit("Can't open %s: zero size device?",disk);
*/
								freearray(devices,disknr);
								return -1;
								}
					freearray(devices,disknr);
					return ant;
						}
					else {	
						erroruit("selectdisk: %d out of range",ant);
						freearray(devices,disknr);
						return -2;
						}
				 }
		}
	editup();
	freearray(devices,disknr);
	return 0;
	}
#endif
